
;CodeVisionAVR C Compiler V2.05.3 Standard
;(C) Copyright 1998-2011 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATtiny2313
;Program type             : Application
;Clock frequency          : 8,000000 MHz
;Memory model             : Tiny
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 32 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;Global 'const' stored in FLASH     : No
;Enhanced function parameter passing: Yes
;Enhanced core instructions         : On
;Smart register allocation          : On
;Automatic register allocation      : On

	#pragma AVRPART ADMIN PART_NAME ATtiny2313
	#pragma AVRPART MEMORY PROG_FLASH 2048
	#pragma AVRPART MEMORY EEPROM 128
	#pragma AVRPART MEMORY INT_SRAM SIZE 223
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU WDTCR=0x21
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU SPL=0x3D
	.EQU SREG=0x3F
	.EQU GPIOR0=0x13
	.EQU GPIOR1=0x14
	.EQU GPIOR2=0x15

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x00DF
	.EQU __DSTACK_SIZE=0x0020
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTW2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	LDI  R24,BYTE3(2*@0+(@1))
	LDI  R25,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _Count=R3
	.DEF _KeyP=R2
	.DEF _StartOn=R5
	.DEF _MIN_T=R6
	.DEF _MAX_T=R8
	.DEF _Temperature=R10

;GPIOR0-GPIOR2 INITIALIZATION VALUES
	.EQU __GPIOR0_INIT=0x00
	.EQU __GPIOR1_INIT=0x00
	.EQU __GPIOR2_INIT=0x00

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer0_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer0_compa_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_0x3:
	.DB  0x28,0xEB,0x32,0xA2,0xE1,0xA4,0x24,0xEA
	.DB  0x20,0xA0
_0x4:
	.DB  0x7A
_0x87:
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x30
	.DB  0xF8

__GLOBAL_INI_TBL:
	.DW  0x0A
	.DW  _DIG
	.DW  _0x3*2

	.DW  0x01
	.DW  _DelyGetTemp
	.DW  _0x4*2

	.DW  0x09
	.DW  0x03
	.DW  _0x87*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	IN   R26,MCUSR
	CBR  R26,8
	OUT  MCUSR,R26
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,__CLEAR_SRAM_SIZE
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;GPIOR0-GPIOR2 INITIALIZATION
	LDI  R30,__GPIOR0_INIT
	OUT  GPIOR0,R30
	;__GPIOR1_INIT = __GPIOR0_INIT
	OUT  GPIOR1,R30
	;__GPIOR2_INIT = __GPIOR0_INIT
	OUT  GPIOR2,R30

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x80

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V2.05.3 Standard
;Automatic Program Generator
; Copyright 1998-2011 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project :
;Version :
;Date    : 16.06.2017
;Author  : PerTic@n
;Company : If You Like This Software,Buy It
;Comments:
;
;
;Chip type               : ATtiny2313
;AVR Core Clock frequency: 8,000000 MHz
;Memory model            : Tiny
;External RAM size       : 0
;Data Stack size         : 32
;*****************************************************/
;
;#include <tiny2313.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x50
	.EQU __sm_powerdown=0x10
	.EQU __sm_standby=0x40
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;
;#include <Digits.c>
;//Digits
;//   
;
;#define N_A  0
;#define N_B  2
;#define N_C  4
;#define N_D  6
;#define N_E  7
;#define N_F  1
;#define N_G  3
;#define N_DP 5
;
;#define _A  (1<<N_A)
;#define _B  (1<<N_B)
;#define _C  (1<<N_C)
;#define _D  (1<<N_D)
;#define _E  (1<<N_E)
;#define _F  (1<<N_F)
;#define _G  (1<<N_G)
;#define _DP (1<<N_DP)
;
;#define _0 ~(_A|_B|_C|_D|_E|_F   )
;#define _1 ~(   _B|_C            )
;#define _2 ~(_A|_B|   _D|_E|   _G)
;#define _3 ~(_A|_B|_C|_D|      _G)
;#define _4 ~(   _B|_C|      _F|_G)
;#define _5 ~(_A|   _C|_D|   _F|_G)
;#define _6 ~(_A|   _C|_D|_E|_F|_G)
;#define _7 ~(_A|_B|_C            )
;#define _8 ~(_A|_B|_C|_D|_E|_F|_G)
;#define _9 ~(_A|_B|_C|_D|   _F|_G)
;#define _a ~(_A|_B|_C|   _E|_F|_G)
;#define _b ~(      _C|_D|_E|_F|_G)
;#define _c ~(_A|      _D|_E|_F|  )
;#define _d ~(   _B|_C|_D|_E|   _G)
;#define _e ~(_A|      _D|_E|_F|_G)
;#define _f ~(_A|         _E|_F|_G)
;#define _Z ~(0                   )
;#define _N ~(                  _G)
; unsigned char DIG[]={_0,_1,_2,_3,_4,_5,_6,_7,_8,_9};

	.DSEG
;
;#define _OFF   PORTD&=0x07
;#define _ON    PORTD|=((8<<NUM)&(0x78))
;//#define _N_Dig PORTB=N_Dig
;#define _N_Dig PORTB=DIGS[NUM];
;#define KEY_IN PIND.1
;eeprom signed int E_MIN_T=50;
;eeprom signed int E_MAX_T=150;
;unsigned char Count=0;
;unsigned char KeyP;
;unsigned char StartOn=0;
;signed int MIN_T;
;signed int MAX_T;
;#define Run PORTA.1
;#define ERR PORTD.2
;unsigned char DIGS[4];
;signed int  Temperature=-2000;
;#include <DS18B20.c>
;//DS18B20
;//if (DelyGetTemp){DelyGetTemp--;}else{GetTemp();}; // 250 
;
;//#define PORTTEMP       PORTD                                    //      
;#define DDRTEMP           DDRD                                    //         
;#define PINTEMP           PIND                                    //         
;//#define BITTEMP            0                                    //       
;#define BT                   0                                    //       
;#define Speed_temp       0.122                                    //    
;
;#define TR0 DDRTEMP |= (1 << BT)
;#define TR1 DDRTEMP &= ~(1 << BT)
;//#define TR0 DDRTEMP.BT=1
;//#define TR1 DDRTEMP.BT=0
;#define RES PINTEMP.BT
;volatile bit           OK_Flag = 0;
;volatile unsigned char  DelyGetTemp = 1000*Speed_temp;                         //    1 .
;//___________________________________________________________________________________________________________________________________________________
;//                                                        DS18B20
;//___________________________________________________________________________________________________________________________________________________
;void DS18B20_init(void)
; 0000 0027  {

	.CSEG
_DS18B20_init:
; //PORTTEMP.BT=0;//PORTTEMP &= ~(1 << BT);           //   
; TR0;                                              //   
	SBI  0x11,0
; delay_us(490);                                    //    480    490
	__DELAY_USW 980
; TR1;                                              // 
	RCALL SUBOPT_0x0
; delay_us(2);
; OK_Flag = ~(RES);                                 //   
	SBIS 0x10,0
	RJMP _0x5
	CBI  0x13,0
	RJMP _0x6
_0x5:
	SBI  0x13,0
_0x6:
; delay_us(70);                                     //    60     68
	__DELAY_USB 187
; OK_Flag |= RES;                                   //     //  OK_Flag = 0  
	LDI  R26,0
	SBIC 0x13,0
	LDI  R26,1
	LDI  R30,0
	SBIC 0x10,0
	LDI  R30,1
	OR   R30,R26
	BRNE _0x7
	CBI  0x13,0
	RJMP _0x8
_0x7:
	SBI  0x13,0
_0x8:
; delay_us(420);                                    //    420     422
	__DELAY_USW 840
; //return OK_Flag;                                   //  
; }
	RET
;//___________________________________________________________________________________________________________________________________________________
;//                                                          DS18B20
;//___________________________________________________________________________________________________________________________________________________
;unsigned char read_18b20(void)
; {
_read_18b20:
; unsigned char i;
; unsigned char dat = 0;
; //#asm("CLI")
; for (i=0; i<8; i++)                               //  
	RCALL __SAVELOCR2
;	i -> R17
;	dat -> R16
	LDI  R16,0
	LDI  R17,LOW(0)
_0xA:
	CPI  R17,8
	BRSH _0xB
;  {
;  TR0;                                          //   
	RCALL SUBOPT_0x1
;  delay_us(2);                                  //    1 
;  TR1;                                          // 
	CBI  0x11,0
;  delay_us(4);                                  //    2 
	__DELAY_USB 11
;  dat|=RES<<i;                                  //  
	LDI  R26,0
	SBIC 0x10,0
	LDI  R26,1
	MOV  R30,R17
	RCALL __LSLB12
	OR   R16,R30
;  delay_us(62);                                 //    2 
	__DELAY_USB 165
;  };
	SUBI R17,-1
	RJMP _0xA
_0xB:
; //#asm("SEI")
; return dat;                                       //  
	MOV  R30,R16
	RCALL __LOADLOCR2P
	RET
; }
;//___________________________________________________________________________________________________________________________________________________
;//                                                          DS18B20
;//___________________________________________________________________________________________________________________________________________________
;void write_18b20(unsigned char dat)
; {
_write_18b20:
; unsigned char i;
; //#asm("CLI")
; for (i = 0;i < 8;i++)
	ST   -Y,R26
	ST   -Y,R17
;	dat -> Y+1
;	i -> R17
	LDI  R17,LOW(0)
_0xD:
	CPI  R17,8
	BRSH _0xE
;  {
;  TR0;
	RCALL SUBOPT_0x1
;  delay_us(2);
;  if (dat & (1<<i)) {TR1;}else{TR0;}
	MOV  R30,R17
	LDI  R26,LOW(1)
	LDI  R27,HIGH(1)
	RCALL __LSLW12
	LDD  R26,Y+1
	LDI  R27,0
	AND  R30,R26
	AND  R31,R27
	SBIW R30,0
	BREQ _0xF
	CBI  0x11,0
	RJMP _0x10
_0xF:
	SBI  0x11,0
_0x10:
;  delay_us(62);
	__DELAY_USB 165
;  TR1;
	RCALL SUBOPT_0x0
;  delay_us(2);
;  };
	SUBI R17,-1
	RJMP _0xD
_0xE:
; //#asm("SEI")
; }
	LDD  R17,Y+0
	RJMP _0x2000001
;//___________________________________________________________________________________________________________________________________________________
;//                                                                  
;//___________________________________________________________________________________________________________________________________________________
;void GetTemp(void)
; {
_GetTemp:
; static   unsigned int StepGetTemp = 0;
; static   unsigned char TermH, TermL;
; switch (StepGetTemp)
	LDS  R30,_StepGetTemp_S0000003000
	LDS  R31,_StepGetTemp_S0000003000+1
;  {        /*DelyGetTemp=750*Speed_temp;*/   case 0:              // ,      ,         
	SBIW R30,0
	BRNE _0x14
;   DS18B20_init();                                            //  DS18B20
	RCALL _DS18B20_init
;  StepGetTemp=1; DelyGetTemp=0;   break; case 1:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RCALL SUBOPT_0x2
	RJMP _0x83
_0x14:
	RCALL SUBOPT_0x3
	BRNE _0x15
;   write_18b20(0xCC);                                         //   
	LDI  R26,LOW(204)
	RCALL _write_18b20
;  StepGetTemp=2; DelyGetTemp=0;   break; case 2:
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	RCALL SUBOPT_0x2
	RJMP _0x83
_0x15:
	RCALL SUBOPT_0x4
	BRNE _0x16
;   write_18b20(0x44);                                         //   
	LDI  R26,LOW(68)
	RCALL _write_18b20
;  StepGetTemp=3; DelyGetTemp=850*Speed_temp; break; case 3:   //  750 
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	STS  _StepGetTemp_S0000003000,R30
	STS  _StepGetTemp_S0000003000+1,R31
	LDI  R30,LOW(103)
	RJMP _0x83
_0x16:
	RCALL SUBOPT_0x5
	BRNE _0x17
;   DS18B20_init();                                            //  DS18B20
	RCALL _DS18B20_init
;  StepGetTemp=4; DelyGetTemp=0;   break; case 4:
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	RCALL SUBOPT_0x2
	RJMP _0x83
_0x17:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x18
;   write_18b20(0xCC);                                         //   
	LDI  R26,LOW(204)
	RCALL _write_18b20
;  StepGetTemp=5; DelyGetTemp=0;   break; case 5:
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	RCALL SUBOPT_0x2
	RJMP _0x83
_0x18:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BRNE _0x19
;   write_18b20(0xBE);                                         //   
	LDI  R26,LOW(190)
	RCALL _write_18b20
;  StepGetTemp=6; DelyGetTemp=0;   break; case 6:
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	RCALL SUBOPT_0x2
	RJMP _0x83
_0x19:
	CPI  R30,LOW(0x6)
	LDI  R26,HIGH(0x6)
	CPC  R31,R26
	BRNE _0x1A
;  // Term = read_18b20()>>4;                                    //    
;   TermL = read_18b20();                                    //    
	RCALL _read_18b20
	STS  _TermL_S0000003000,R30
;   //TermL=16;
;  StepGetTemp=7; DelyGetTemp=0;   break; case 7:
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	RCALL SUBOPT_0x2
	RJMP _0x83
_0x1A:
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	BRNE _0x1B
;  // Term |= read_18b20()<<4;                                   //    
;   TermH = read_18b20();                                   //    
	RCALL _read_18b20
	STS  _TermH_S0000003000,R30
;  // TermH = 1;
;  ////Term = (OK_Flag == 0)? ((Temp_L>>4)|(Temp_H<<4)):-126;
;   //if (OK_Flag != 0) Term = -126;
;   StepGetTemp=8; DelyGetTemp=0;   break; case 8:
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	RCALL SUBOPT_0x2
	RJMP _0x83
_0x1B:
	CPI  R30,LOW(0x8)
	LDI  R26,HIGH(0x8)
	CPC  R31,R26
	BRNE _0x21
;   //if (Term<0) Term=(-Term)|0x80;                             //     .
;    //Term=0x8100;
;    //Temperature=(TermH<<8)+TermL;
;    //if (Temperature<0) Temperature=(-Temperature)|0x8000;
;    //if (OK_Flag != 0) Temperature = -2050;
;    //Temperature=(Temperature<0)? ((-Temperature)|0x8000):(Temperature);
;    //Temperature=(Temperature*10)>>4;
;    Temperature=(((TermH<<8)+TermL)*10)>>4;
	LDS  R27,_TermH_S0000003000
	LDI  R26,LOW(0)
	LDS  R30,_TermL_S0000003000
	RCALL SUBOPT_0x6
	ADD  R26,R30
	ADC  R27,R31
	RCALL SUBOPT_0x7
	RCALL __MULW12
	RCALL __ASRW4
	MOVW R10,R30
;    if (OK_Flag != 0) {Temperature = -2000; Count=0;};
	SBIS 0x13,0
	RJMP _0x1D
	LDI  R30,LOW(63536)
	LDI  R31,HIGH(63536)
	MOVW R10,R30
	CLR  R3
_0x1D:
;    Count+=(~Count)? 1:0;
	MOV  R30,R3
	COM  R30
	CPI  R30,0
	BREQ _0x1E
	LDI  R30,LOW(1)
	RJMP _0x1F
_0x1E:
	LDI  R30,LOW(0)
_0x1F:
	ADD  R3,R30
;  default: StepGetTemp=0;
_0x21:
	LDI  R30,LOW(0)
	STS  _StepGetTemp_S0000003000,R30
	STS  _StepGetTemp_S0000003000+1,R30
;  DelyGetTemp=1000*Speed_temp;                                //    1
	LDI  R30,LOW(122)
_0x83:
	STS  _DelyGetTemp,R30
;  };
; }
	RET
;
;#define L_Max 254
;#define L_Min 2
;
;void digit(signed int ish)
; 0000 002C {
_digit:
; 0000 002D if (0>ish)  {ish=-ish; DIGS[3]=~_G;}else{if (999<ish) {DIGS[3]=DIG[1]; ish-=1000;}else{DIGS[3]=~0;};};
	ST   -Y,R27
	ST   -Y,R26
;	ish -> Y+0
	LDD  R30,Y+1
	TST  R30
	BRPL _0x22
	RCALL SUBOPT_0x8
	RCALL __ANEGW1
	RCALL SUBOPT_0x9
	LDI  R30,LOW(247)
	RJMP _0x84
_0x22:
	RCALL SUBOPT_0x8
	CPI  R30,LOW(0x3E8)
	LDI  R26,HIGH(0x3E8)
	CPC  R31,R26
	BRLT _0x24
	__GETB1MN _DIG,1
	__PUTB1MN _DIGS,3
	RCALL SUBOPT_0x8
	SUBI R30,LOW(1000)
	SBCI R31,HIGH(1000)
	RCALL SUBOPT_0x9
	RJMP _0x25
_0x24:
	LDI  R30,LOW(255)
_0x84:
	__PUTB1MN _DIGS,3
_0x25:
; 0000 002E if (1280<ish) {DIGS[2]=~_G; DIGS[1]=~_G; DIGS[0]=~_G;}
	RCALL SUBOPT_0x8
	CPI  R30,LOW(0x501)
	LDI  R26,HIGH(0x501)
	CPC  R31,R26
	BRLT _0x26
	LDI  R30,LOW(247)
	__PUTB1MN _DIGS,2
	__PUTB1MN _DIGS,1
	STS  _DIGS,R30
; 0000 002F else
	RJMP _0x27
_0x26:
; 0000 0030   {
; 0000 0031   DIGS[0]=DIG[ish%10];
	RCALL SUBOPT_0xA
	RCALL __MODW21
	SUBI R30,-LOW(_DIG)
	LD   R30,Z
	STS  _DIGS,R30
; 0000 0032   ish/=10;
	RCALL SUBOPT_0xA
	RCALL __DIVW21
	RCALL SUBOPT_0x9
; 0000 0033   DIGS[2]=DIG[ish%10]&(~_DP);
	RCALL SUBOPT_0xA
	RCALL __MODW21
	SUBI R30,-LOW(_DIG)
	LD   R30,Z
	ANDI R30,0xDF
	__PUTB1MN _DIGS,2
; 0000 0034   ish/=10;
	RCALL SUBOPT_0xA
	RCALL __DIVW21
	RCALL SUBOPT_0x9
; 0000 0035   DIGS[1]=DIG[ish];
	LD   R30,Y
	SUBI R30,-LOW(_DIG)
	LD   R30,Z
	__PUTB1MN _DIGS,1
; 0000 0036   };
_0x27:
; 0000 0037 }
_0x2000001:
	ADIW R28,2
	RET
;
;// Timer 0 output compare A interrupt service routine
;interrupt [TIM0_COMPA] void timer0_compa_isr(void)
; 0000 003B {
_timer0_compa_isr:
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
; 0000 003C //ERR=1;
; 0000 003D if (KEY_IN) KeyP|=PORTD&0x78;
	SBIS 0x10,1
	RJMP _0x28
	IN   R30,0x12
	ANDI R30,LOW(0x78)
	OR   R2,R30
; 0000 003E _OFF;
_0x28:
	IN   R30,0x12
	ANDI R30,LOW(0x7)
	OUT  0x12,R30
; 0000 003F }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	RETI
;
;interrupt [TIM0_OVF] void timer0_ovf_isr(void)
; 0000 0042 {//ERR=1;
_timer0_ovf_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 0043 static unsigned char NUM;
; 0000 0044 static unsigned char Msec;
; 0000 0045 //static unsigned char DelyGetTemp;
; 0000 0046 //static unsigned int  Sec;
; 0000 0047 //static signed int  Temperature;
; 0000 0048 //static unsigned int  SecStop;
; 0000 0049 //static unsigned int  SuHo;
; 0000 004A //static unsigned int  Pokaz;
; 0000 004B //static unsigned char KeyP;
; 0000 004C static unsigned char menu=0;
; 0000 004D //if (KEY_IN) KeyP|=PORTD&(0xFF);
; 0000 004E //if (KEY_IN) KeyP|=PORTD;
; 0000 004F //_OFF;
; 0000 0050 _N_Dig;
	LDS  R30,_NUM_S0000006000
	SUBI R30,-LOW(_DIGS)
	LD   R30,Z
	OUT  0x18,R30
; 0000 0051 _ON;
	IN   R1,18
	LDS  R30,_NUM_S0000006000
	LDI  R26,LOW(8)
	RCALL __LSLB12
	ANDI R30,LOW(0x78)
	OR   R30,R1
	OUT  0x12,R30
; 0000 0052 #asm("sei")
	sei
; 0000 0053 NUM=++NUM&3;
	LDS  R26,_NUM_S0000006000
	SUBI R26,-LOW(1)
	STS  _NUM_S0000006000,R26
	LDI  R30,LOW(3)
	AND  R30,R26
	STS  _NUM_S0000006000,R30
; 0000 0054 switch (NUM)
	RCALL SUBOPT_0x6
; 0000 0055 {
; 0000 0056 case 2:
	RCALL SUBOPT_0x4
	BREQ PC+2
	RJMP _0x2C
; 0000 0057        Msec=++Msec&31;
	LDS  R26,_Msec_S0000006000
	SUBI R26,-LOW(1)
	STS  _Msec_S0000006000,R26
	LDI  R30,LOW(31)
	AND  R30,R26
	STS  _Msec_S0000006000,R30
; 0000 0058        if (0==KeyP) Msec=0;
	TST  R2
	BRNE _0x2D
	LDI  R30,LOW(0)
	STS  _Msec_S0000006000,R30
; 0000 0059        if (!Msec)
_0x2D:
	LDS  R30,_Msec_S0000006000
	CPI  R30,0
	BREQ PC+2
	RJMP _0x2E
; 0000 005A        switch (menu)
	LDS  R30,_menu_S0000006000
	RCALL SUBOPT_0xB
; 0000 005B        {
; 0000 005C        case 0:switch (KeyP)               //    
	BRNE _0x32
	MOV  R30,R2
	RCALL SUBOPT_0xB
; 0000 005D               {
; 0000 005E               case  0:
	BRNE _0x36
; 0000 005F                       digit(Temperature);
	MOVW R26,R10
	RJMP _0x85
; 0000 0060                       break;
; 0000 0061               case 16:
_0x36:
	RCALL SUBOPT_0xC
	BRNE _0x37
; 0000 0062                       digit(MIN_T);
	RCALL SUBOPT_0xD
; 0000 0063                       DIGS[3]&=~_E;
; 0000 0064                       break;
	RJMP _0x35
; 0000 0065               case 32:
_0x37:
	RCALL SUBOPT_0xE
	BRNE _0x38
; 0000 0066                       digit(MAX_T);
	RCALL SUBOPT_0xF
; 0000 0067                       DIGS[3]&=~_F;
; 0000 0068                       break;
	RJMP _0x35
; 0000 0069               case 48:
_0x38:
	RCALL SUBOPT_0x10
	BRNE _0x3A
; 0000 006A                       digit(-3000);
	RCALL SUBOPT_0x11
; 0000 006B                       menu=1;
	LDI  R30,LOW(1)
	RCALL SUBOPT_0x12
; 0000 006C                       break;
	RJMP _0x35
; 0000 006D               default: digit(KeyP);
_0x3A:
	MOV  R26,R2
	CLR  R27
_0x85:
	RCALL _digit
; 0000 006E               }break;
_0x35:
	RJMP _0x31
; 0000 006F        case 1:
_0x32:
	RCALL SUBOPT_0x3
	BRNE _0x3B
; 0000 0070               DIGS[3]&=~_E;
	__POINTB2MN _DIGS,3
	LD   R30,X
	ANDI R30,0x7F
	ST   X,R30
; 0000 0071               if (0==KeyP) menu=2;
	TST  R2
	BRNE _0x3C
	LDI  R30,LOW(2)
	RCALL SUBOPT_0x12
; 0000 0072               break;
_0x3C:
	RJMP _0x31
; 0000 0073        case 2:switch (KeyP)                //
_0x3B:
	RCALL SUBOPT_0x4
	BRNE _0x3D
	MOV  R30,R2
	RCALL SUBOPT_0xB
; 0000 0074               {
; 0000 0075               case  0:
	BRNE _0x41
; 0000 0076                       digit(MIN_T);
	RCALL SUBOPT_0xD
; 0000 0077                       DIGS[3]&=~_E;
; 0000 0078                       break;
	RJMP _0x40
; 0000 0079               case 16:
_0x41:
	RCALL SUBOPT_0xC
	BRNE _0x42
; 0000 007A                       MIN_T--;
	MOVW R30,R6
	SBIW R30,1
	MOVW R6,R30
; 0000 007B                       MIN_T+=(-550>MIN_T)? 1:0;
	LDI  R26,LOW(64986)
	LDI  R27,HIGH(64986)
	CP   R6,R26
	CPC  R7,R27
	BRGE _0x43
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP _0x44
_0x43:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
_0x44:
	__ADDWRR 6,7,30,31
; 0000 007C                       digit(MIN_T);
	RCALL SUBOPT_0xD
; 0000 007D                       DIGS[3]&=~_E;
; 0000 007E                       break;
	RJMP _0x40
; 0000 007F               case 32:
_0x42:
	RCALL SUBOPT_0xE
	BRNE _0x46
; 0000 0080                       MIN_T++;
	MOVW R30,R6
	ADIW R30,1
	MOVW R6,R30
; 0000 0081                       if (MAX_T<=MIN_T) MIN_T=MAX_T-1;
	__CPWRR 6,7,8,9
	BRLT _0x47
	MOVW R30,R8
	SBIW R30,1
	MOVW R6,R30
; 0000 0082                       digit(MIN_T);
_0x47:
	RCALL SUBOPT_0xD
; 0000 0083                       DIGS[3]&=~_E;
; 0000 0084                       break;
	RJMP _0x40
; 0000 0085               case 48:
_0x46:
	RCALL SUBOPT_0x10
	BRNE _0x49
; 0000 0086                       digit(-3000);
	RCALL SUBOPT_0x11
; 0000 0087                       menu=3;
	LDI  R30,LOW(3)
	RCALL SUBOPT_0x12
; 0000 0088                       break;
	RJMP _0x40
; 0000 0089               default: digit(KeyP);
_0x49:
	MOV  R26,R2
	CLR  R27
	RCALL _digit
; 0000 008A               }break;
_0x40:
	RJMP _0x31
; 0000 008B        case 3:
_0x3D:
	RCALL SUBOPT_0x5
	BRNE _0x4A
; 0000 008C               DIGS[3]&=~_F;
	__POINTB2MN _DIGS,3
	LD   R30,X
	ANDI R30,0xFD
	ST   X,R30
; 0000 008D               if (0==KeyP) menu=4;
	TST  R2
	BRNE _0x4B
	LDI  R30,LOW(4)
	RCALL SUBOPT_0x12
; 0000 008E               break;
_0x4B:
	RJMP _0x31
; 0000 008F        case 4:switch (KeyP)               //
_0x4A:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x4C
	MOV  R30,R2
	RCALL SUBOPT_0xB
; 0000 0090               {
; 0000 0091               case  0:
	BRNE _0x50
; 0000 0092                       digit(MAX_T);
	RCALL SUBOPT_0xF
; 0000 0093                       DIGS[3]&=~_F;
; 0000 0094                       break;
	RJMP _0x4F
; 0000 0095               case 16:
_0x50:
	RCALL SUBOPT_0xC
	BRNE _0x51
; 0000 0096                       MAX_T--;
	MOVW R30,R8
	SBIW R30,1
	MOVW R8,R30
; 0000 0097                       if (MAX_T<=MIN_T) MAX_T=MIN_T+1;
	__CPWRR 6,7,8,9
	BRLT _0x52
	MOVW R30,R6
	ADIW R30,1
	MOVW R8,R30
; 0000 0098                       digit(MAX_T);
_0x52:
	RCALL SUBOPT_0xF
; 0000 0099                       DIGS[3]&=~_F;
; 0000 009A                       break;
	RJMP _0x4F
; 0000 009B               case 32:
_0x51:
	RCALL SUBOPT_0xE
	BRNE _0x53
; 0000 009C                       MAX_T++;
	MOVW R30,R8
	ADIW R30,1
	MOVW R8,R30
; 0000 009D                       MAX_T-=(1250<MAX_T)? 1:0;
	LDI  R26,LOW(1250)
	LDI  R27,HIGH(1250)
	CP   R26,R8
	CPC  R27,R9
	BRGE _0x54
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP _0x55
_0x54:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
_0x55:
	__SUBWRR 8,9,30,31
; 0000 009E                       digit(MAX_T);
	RCALL SUBOPT_0xF
; 0000 009F                       DIGS[3]&=~_F;
; 0000 00A0                       break;
	RJMP _0x4F
; 0000 00A1               case 48:
_0x53:
	RCALL SUBOPT_0x10
	BRNE _0x58
; 0000 00A2                       digit(-3000);
	RCALL SUBOPT_0x11
; 0000 00A3                       menu=5;
	LDI  R30,LOW(5)
	RCALL SUBOPT_0x12
; 0000 00A4                       break;
	RJMP _0x4F
; 0000 00A5               default: digit(KeyP);
_0x58:
	MOV  R26,R2
	CLR  R27
	RCALL _digit
; 0000 00A6               }; break;
_0x4F:
	RJMP _0x31
; 0000 00A7        case 5:
_0x4C:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BRNE _0x59
; 0000 00A8               if (0==KeyP)
	TST  R2
	BRNE _0x5A
; 0000 00A9                  {
; 0000 00AA                  menu=6;
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x12
; 0000 00AB                  E_MIN_T=MIN_T;
	MOVW R30,R6
	LDI  R26,LOW(_E_MIN_T)
	LDI  R27,HIGH(_E_MIN_T)
	RCALL __EEPROMWRW
; 0000 00AC                  E_MAX_T=MAX_T;
	MOVW R30,R8
	LDI  R26,LOW(_E_MAX_T)
	LDI  R27,HIGH(_E_MAX_T)
	RCALL __EEPROMWRW
; 0000 00AD                  Count=0;
	CLR  R3
; 0000 00AE                  menu=0;
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x12
; 0000 00AF                  };
_0x5A:
; 0000 00B0                break;
	RJMP _0x31
; 0000 00B1        case 6: break;
_0x59:
	CPI  R30,LOW(0x6)
	LDI  R26,HIGH(0x6)
	CPC  R31,R26
	BREQ _0x31
; 0000 00B2        default: menu=0;
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x12
; 0000 00B3        };
_0x31:
_0x2E:
; 0000 00B4               KeyP=0;
	CLR  R2
; 0000 00B5  if (DelyGetTemp){DelyGetTemp--;}else{GetTemp();}; // 250
	LDS  R30,_DelyGetTemp
	CPI  R30,0
	BREQ _0x5D
	LDS  R30,_DelyGetTemp
	SUBI R30,LOW(1)
	STS  _DelyGetTemp,R30
	RJMP _0x5E
_0x5D:
	RCALL _GetTemp
_0x5E:
; 0000 00B6 
; 0000 00B7         break;
	RJMP _0x2B
; 0000 00B8 case 3: //  (m4Sec>=125)
_0x2C:
	RCALL SUBOPT_0x5
	BREQ _0x2B
; 0000 00B9         //digit(Temperature);
; 0000 00BA         break;
; 0000 00BB case 0:
	SBIW R30,0
	BRNE _0x60
; 0000 00BC        if (PINA.0) {OCR0A+=(L_Max>OCR0A)? 1:0;}       //
	SBIS 0x19,0
	RJMP _0x61
	IN   R30,0x36
	MOV  R26,R30
	IN   R30,0x36
	CPI  R30,LOW(0xFE)
	BRSH _0x62
	LDI  R30,LOW(1)
	RJMP _0x63
_0x62:
	LDI  R30,LOW(0)
_0x63:
	ADD  R30,R26
	RJMP _0x86
; 0000 00BD        else {OCR0A-=(L_Min<OCR0A)? 1:0;};
_0x61:
	IN   R30,0x36
	MOV  R26,R30
	IN   R30,0x36
	CPI  R30,LOW(0x3)
	BRLO _0x66
	LDI  R30,LOW(1)
	RJMP _0x67
_0x66:
	LDI  R30,LOW(0)
_0x67:
	RCALL __SWAPB12
	SUB  R30,R26
_0x86:
	OUT  0x36,R30
; 0000 00BE        break;
	RJMP _0x2B
; 0000 00BF case 1:
_0x60:
	RCALL SUBOPT_0x3
	BRNE _0x2B
; 0000 00C0         if ((8<Count)&&(0==menu))                                  //- 
	LDI  R26,LOW(8)
	CP   R26,R3
	BRSH _0x6B
	LDS  R30,_menu_S0000006000
	CPI  R30,0
	BREQ _0x6C
_0x6B:
	RJMP _0x6A
_0x6C:
; 0000 00C1          {
; 0000 00C2          if (MIN_T>Temperature) {if (StartOn) Run=1; else Run=0;};
	__CPWRR 10,11,6,7
	BRGE _0x6D
	TST  R5
	BREQ _0x6E
	SBI  0x1B,1
	RJMP _0x71
_0x6E:
	CBI  0x1B,1
_0x71:
_0x6D:
; 0000 00C3          if (MAX_T<Temperature) {if (StartOn) Run=0; else Run=1;};
	__CPWRR 8,9,10,11
	BRGE _0x74
	TST  R5
	BREQ _0x75
	CBI  0x1B,1
	RJMP _0x78
_0x75:
	SBI  0x1B,1
_0x78:
_0x74:
; 0000 00C4          }
; 0000 00C5 
; 0000 00C6         break;
_0x6A:
; 0000 00C7 };
_0x2B:
; 0000 00C8 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;
;// Declare your global variables here
;void main(void)
; 0000 00CC {
_main:
; 0000 00CD // Declare your local variables here
; 0000 00CE 
; 0000 00CF // Crystal Oscillator division factor: 1
; 0000 00D0 #pragma optsize-
; 0000 00D1 CLKPR=0x80;
	LDI  R30,LOW(128)
	OUT  0x26,R30
; 0000 00D2 CLKPR=0x00;
	LDI  R30,LOW(0)
	OUT  0x26,R30
; 0000 00D3 #ifdef _OPTIMIZE_SIZE_
; 0000 00D4 #pragma optsize+
; 0000 00D5 #endif
; 0000 00D6 
; 0000 00D7 // Input/Output Ports initialization
; 0000 00D8 // Port A initialization
; 0000 00D9 // Func2=In Func1=In Func0=In
; 0000 00DA // State2=P State1=T State0=P
; 0000 00DB PORTA=0x05;
	LDI  R30,LOW(5)
	OUT  0x1B,R30
; 0000 00DC DDRA=0x00;
	LDI  R30,LOW(0)
	OUT  0x1A,R30
; 0000 00DD 
; 0000 00DE // Port B initialization
; 0000 00DF // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
; 0000 00E0 // State7=1 State6=1 State5=1 State4=1 State3=1 State2=1 State1=1 State0=1
; 0000 00E1 PORTB=0xFF;
	LDI  R30,LOW(255)
	OUT  0x18,R30
; 0000 00E2 DDRB=0xFF;
	OUT  0x17,R30
; 0000 00E3 
; 0000 00E4 // Port D initialization
; 0000 00E5 // Func6=Out Func5=Out Func4=Out Func3=Out Func2=In Func1=In Func0=In
; 0000 00E6 // State6=0 State5=0 State4=0 State3=0 State2=P State1=T State0=T
; 0000 00E7 PORTD=0x04;
	LDI  R30,LOW(4)
	OUT  0x12,R30
; 0000 00E8 DDRD=0x7C;
	LDI  R30,LOW(124)
	OUT  0x11,R30
; 0000 00E9 
; 0000 00EA // Timer/Counter 0 initialization
; 0000 00EB // Clock source: System Clock
; 0000 00EC // Clock value: 125,000 kHz
; 0000 00ED // Mode: Normal top=0xFF
; 0000 00EE // OC0A output: Disconnected
; 0000 00EF // OC0B output: Disconnected
; 0000 00F0 TCCR0A=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 00F1 TCCR0B=0x03;
	LDI  R30,LOW(3)
	OUT  0x33,R30
; 0000 00F2 TCNT0=0x00;
	LDI  R30,LOW(0)
	OUT  0x32,R30
; 0000 00F3 OCR0A=0xFA;
	LDI  R30,LOW(250)
	OUT  0x36,R30
; 0000 00F4 OCR0B=0x00;
	LDI  R30,LOW(0)
	OUT  0x3C,R30
; 0000 00F5 
; 0000 00F6 // Timer/Counter 1 initialization
; 0000 00F7 // Clock source: System Clock
; 0000 00F8 // Clock value: Timer1 Stopped
; 0000 00F9 // Mode: Normal top=0xFFFF
; 0000 00FA // OC1A output: Discon.
; 0000 00FB // OC1B output: Discon.
; 0000 00FC // Noise Canceler: Off
; 0000 00FD // Input Capture on Falling Edge
; 0000 00FE // Timer1 Overflow Interrupt: Off
; 0000 00FF // Input Capture Interrupt: Off
; 0000 0100 // Compare A Match Interrupt: Off
; 0000 0101 // Compare B Match Interrupt: Off
; 0000 0102 TCCR1A=0x00;
	OUT  0x2F,R30
; 0000 0103 TCCR1B=0x00;
	OUT  0x2E,R30
; 0000 0104 //TCNT1H=0x00;
; 0000 0105 //TCNT1L=0x00;
; 0000 0106 //ICR1H=0x00;
; 0000 0107 //ICR1L=0x00;
; 0000 0108 //OCR1AH=0x00;
; 0000 0109 //OCR1AL=0x00;
; 0000 010A //OCR1BH=0x00;
; 0000 010B //OCR1BL=0x00;
; 0000 010C 
; 0000 010D // External Interrupt(s) initialization
; 0000 010E // INT0: Off
; 0000 010F // INT1: Off
; 0000 0110 // Interrupt on any change on pins PCINT0-7: Off
; 0000 0111 //GIMSK=0x00;
; 0000 0112 MCUCR=0x20;
	LDI  R30,LOW(32)
	OUT  0x35,R30
; 0000 0113 
; 0000 0114 // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 0115 TIMSK=0x03;
	LDI  R30,LOW(3)
	OUT  0x39,R30
; 0000 0116 
; 0000 0117 // Universal Serial Interface initialization
; 0000 0118 // Mode: Disabled
; 0000 0119 // Clock source: Register & Counter=no clk.
; 0000 011A // USI Counter Overflow Interrupt: Off
; 0000 011B //USICR=0x00;
; 0000 011C 
; 0000 011D // USART initialization
; 0000 011E // USART disabled
; 0000 011F //UCSRB=0x00;
; 0000 0120 
; 0000 0121 // Analog Comparator initialization
; 0000 0122 // Analog Comparator: Off
; 0000 0123 // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 0124 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 0125 //DIDR=0x00;
; 0000 0126 StartOn=0;
	CLR  R5
; 0000 0127 delay_us(100);
	__DELAY_USW 200
; 0000 0128 if (PINA.1) StartOn=1;
	SBIS 0x19,1
	RJMP _0x7B
	LDI  R30,LOW(1)
	MOV  R5,R30
; 0000 0129 if (StartOn) Run=1;
_0x7B:
	TST  R5
	BREQ _0x7C
	SBI  0x1B,1
; 0000 012A DDRA=2;
_0x7C:
	LDI  R30,LOW(2)
	OUT  0x1A,R30
; 0000 012B //delay_us(100);
; 0000 012C 
; 0000 012D //Run=1;
; 0000 012E //if (~E_MIN_T) E_MIN_T=0;
; 0000 012F //if (~E_MAX_T) E_MAX_T=50;
; 0000 0130 MIN_T=E_MIN_T;
	LDI  R26,LOW(_E_MIN_T)
	LDI  R27,HIGH(_E_MIN_T)
	RCALL __EEPROMRDW
	MOVW R6,R30
; 0000 0131 MAX_T=E_MAX_T;
	LDI  R26,LOW(_E_MAX_T)
	LDI  R27,HIGH(_E_MAX_T)
	RCALL __EEPROMRDW
	MOVW R8,R30
; 0000 0132 //OSCCAL=20;
; 0000 0133 // Global enable interrupts
; 0000 0134 #asm("sei")
	sei
; 0000 0135 
; 0000 0136 while (1)
_0x7F:
; 0000 0137       {
; 0000 0138       // Place your code here
; 0000 0139       //ERR=0;
; 0000 013A       #asm("sleep")
	sleep
; 0000 013B       }
	RJMP _0x7F
; 0000 013C }
_0x82:
	RJMP _0x82

	.DSEG
_DIG:
	.BYTE 0xA

	.ESEG
_E_MIN_T:
	.DB  0x32,0x0
_E_MAX_T:
	.DB  0x96,0x0

	.DSEG
_DIGS:
	.BYTE 0x4
_DelyGetTemp:
	.BYTE 0x1
_StepGetTemp_S0000003000:
	.BYTE 0x2
_TermH_S0000003000:
	.BYTE 0x1
_TermL_S0000003000:
	.BYTE 0x1
_NUM_S0000006000:
	.BYTE 0x1
_Msec_S0000006000:
	.BYTE 0x1
_menu_S0000006000:
	.BYTE 0x1

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x0:
	CBI  0x11,0
	__DELAY_USB 5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1:
	SBI  0x11,0
	__DELAY_USB 5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0x2:
	STS  _StepGetTemp_S0000003000,R30
	STS  _StepGetTemp_S0000003000+1,R31
	LDI  R30,LOW(0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x3:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x4:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x5:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x6:
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x7:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x8:
	LD   R30,Y
	LDD  R31,Y+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x9:
	ST   Y,R30
	STD  Y+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xA:
	LD   R26,Y
	LDD  R27,Y+1
	RJMP SUBOPT_0x7

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xB:
	RCALL SUBOPT_0x6
	SBIW R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xC:
	CPI  R30,LOW(0x10)
	LDI  R26,HIGH(0x10)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0xD:
	MOVW R26,R6
	RCALL _digit
	__POINTB2MN _DIGS,3
	LD   R30,X
	ANDI R30,0x7F
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xE:
	CPI  R30,LOW(0x20)
	LDI  R26,HIGH(0x20)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0xF:
	MOVW R26,R8
	RCALL _digit
	__POINTB2MN _DIGS,3
	LD   R30,X
	ANDI R30,0xFD
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x10:
	CPI  R30,LOW(0x30)
	LDI  R26,HIGH(0x30)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x11:
	LDI  R26,LOW(62536)
	LDI  R27,HIGH(62536)
	RJMP _digit

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x12:
	STS  _menu_S0000006000,R30
	RET


	.CSEG
__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__LSLB12:
	TST  R30
	MOV  R0,R30
	MOV  R30,R26
	BREQ __LSLB12R
__LSLB12L:
	LSL  R30
	DEC  R0
	BRNE __LSLB12L
__LSLB12R:
	RET

__LSLW12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	BREQ __LSLW12R
__LSLW12L:
	LSL  R30
	ROL  R31
	DEC  R0
	BRNE __LSLW12L
__LSLW12R:
	RET

__ASRW4:
	ASR  R31
	ROR  R30
__ASRW3:
	ASR  R31
	ROR  R30
__ASRW2:
	ASR  R31
	ROR  R30
	ASR  R31
	ROR  R30
	RET

__MULW12U:
	MOV  R0,R26
	MOV  R1,R27
	LDI  R24,17
	CLR  R26
	SUB  R27,R27
	RJMP __MULW12U1
__MULW12U3:
	BRCC __MULW12U2
	ADD  R26,R0
	ADC  R27,R1
__MULW12U2:
	LSR  R27
	ROR  R26
__MULW12U1:
	ROR  R31
	ROR  R30
	DEC  R24
	BRNE __MULW12U3
	RET

__MULW12:
	RCALL __CHKSIGNW
	RCALL __MULW12U
	BRTC __MULW121
	RCALL __ANEGW1
__MULW121:
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__MODW21:
	CLT
	SBRS R27,7
	RJMP __MODW211
	COM  R26
	COM  R27
	ADIW R26,1
	SET
__MODW211:
	SBRC R31,7
	RCALL __ANEGW1
	RCALL __DIVW21U
	MOVW R30,R26
	BRTC __MODW212
	RCALL __ANEGW1
__MODW212:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__EEPROMRDW:
	ADIW R26,1
	RCALL __EEPROMRDB
	MOV  R31,R30
	SBIW R26,1

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRW:
	RCALL __EEPROMWRB
	ADIW R26,1
	PUSH R30
	MOV  R30,R31
	RCALL __EEPROMWRB
	POP  R30
	SBIW R26,1
	RET

__EEPROMWRB:
	SBIS EECR,EEWE
	RJMP __EEPROMWRB1
	WDR
	RJMP __EEPROMWRB
__EEPROMWRB1:
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR2P:
	LD   R16,Y+
	LD   R17,Y+
	RET

;END OF CODE MARKER
__END_OF_CODE:
